// Form1.cpp (Test Server)

#include "stdafx.h"

#include "Form1.h"

using namespace TestServer;

void Form1::ServerShutdownRequestCallback()
{
  Thread::Sleep(3000);  // Just to allow the user to notice the shutdown message
  Invoke(gcnew Action(this, &Form1::Close));
}

void Form1::ServerStatusReportCallback(int nThreadId)
{
  lblRemoteAccessThreadId->Invoke(gcnew Action<String ^>(lblRemoteAccessThreadId, &Label::Text::set),
    String::Format("Remote access thread ID: {0}", nThreadId));
}

System::Void Form1::timer1_Tick(System::Object^  sender, System::EventArgs^  e)
{
  lblHeartbeat->Visible = !lblHeartbeat->Visible;
  lblServerObjectCount->Text = String::Format("Live server object count: {0}", TestServer::Server::GetServerObjectCount());
  lstbInstanceStatus->Items->Clear();
  lstbInstanceStatus->Items->AddRange(TestServer::Server::GetInstanceInfo());
}

System::Void Form1::Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e)
{
  // Don't interfere in case of an exception exit - CloseReason should never have that value during graceful app shutdown
  if (e->CloseReason != CloseReason::ApplicationExitCall)
    if (!TestServer::Server::IsPrimaryServerInstanceIdle())
      e->Cancel = MessageBox::Show(this, "Currently there are active clients attached to the server. Do you still want to "
        "shut down the server?", Text, MessageBoxButtons::OKCancel, MessageBoxIcon::Warning) != Windows::Forms::DialogResult::OK;
}
